﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;
using System.IO;
using System.Diagnostics;
namespace CustomOrderInGroup
{
    /// <summary>
    /// Interaction logic for Window2.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            //xamDataGrid1.DataSource = new List<Data2>
            //{

            //    new Data2 { ID = 3.345, Abbreviation = "z" },
            //    new Data2 { ID = 3.245, Abbreviation = "a" },
            //    new Data2 { ID = 3.145, Abbreviation = "a" },
            //    new Data2 { ID = 30.145, Abbreviation = "a30" },
            //    new Data2 { ID = 1.145, Abbreviation = "b"},
            //    new Data2 { ID = 10.145, Abbreviation = "b10"},
            //    new Data2 { ID = 5.145, Abbreviation = "3v"},
            //    new Data2 { ID = 50.145, Abbreviation = "3v50"},
            //    new Data2 { ID = 2.145, Abbreviation = "c"},
            //    new Data2 { ID = 20.145, Abbreviation = "c20"},
            //};

            List<Data2> gdSource = new List<Data2>();
            for (int cnt1 = 0; cnt1 <= 5; cnt1++)
            {
                //gdSource.Add(new Data2 { ID = 1.1234 * cnt1, Abbreviation = "This is column is for Abbreviation of Z" + cnt1.ToString(), IDName = "N" + (2 * cnt1).ToString() });
                gdSource.Add(new Data2 { ID = 1.1234 * cnt1, Abbreviation = "Z" + cnt1.ToString(), IDName = "N" + (2 * cnt1).ToString() });
            }
            xamDataGrid1.DataSource = gdSource;
            
        }

        private void xamDataGrid1_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            foreach (var item in xamDataGrid1.Records)
            {
                string[] text1 = item.Description.Split(new char[] { '(' });

                item.Description = "";
                if (text1.Length > 2)
                {
                    item.Description += text1[0];
                    for (int i = 1; i < text1.Length - 1; i++)
                    {
                        item.Description += "(" + text1[i];
                    }

                }
                else
                    item.Description = text1[0];
            }
        }
        public void ExportGrid(XamDataGrid grid)
        {
            // with a file
            string file = "";
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            Workbook wb = new Workbook();
            for (int intc = 0; intc <= 20; intc++)
            {
                try
                {
                    file = System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "test" + intc.ToString() + ".xls");
                    wb = exporter.Export(grid, file, WorkbookFormat.Excel97To2003);
                    break;
                }
                catch
                {
                }
            }
            if (wb != null)
            {
                wb.Save(file);
                Process.Start(file);
            }
            else
            {

            }

        }

        private void Export_Click(object sender, RoutedEventArgs e)
        {
            ExportGrid(xamDataGrid1);
        }
    }
    public class Data2
    {
        public double ID { get; set; }
        public string Abbreviation { get; set; }
        public string IDName { get; set; }
    }
    public class SummaryTextFormat : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            SummaryResult sr = (value as SummaryResult);
            //string[] tmp = sr.DisplayText.Split(new char[0], Int32.MaxValue, StringSplitOptions.None);
            string strformat = "N1"; // Data.DataSource.dicColFrmts[sr.SourceField.Name];
            if (sr.Value != null)
            {
                return Double.Parse(sr.Value.ToString()).ToString(strformat);
            }
            return Double.Parse("0").ToString(strformat);
            return sr.Value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }
}
